#!/bin/bash
#
# i3logstat.sh  version 2.0  print alignment job statistics
#

awk '
  /^start at/ { m0 = $4; d0 = $5; t0 = $6 }
  /^normal end at/ { m1 = $5; d1 = $6; t1 = $7 }
  END {
    if ( m1 ) {
      if ( m0 == m1 ) {
        split( t0, t0a, ":" )
        split( t1, t1a, ":" )
        dd = d1 - d0
        dh = t1a[1] - t0a[1]
        dm = t1a[2] - t0a[2]
        ds = t1a[3] - t0a[3]
        if ( ds < 0 ) { ds += 60; dm-- }
        if ( dm < 0 ) { dm += 60; dh-- }
        if ( dh < 0 ) { dh += 24; dd-- }
        if ( dd < 0 ) {
          print "-99:99:99"
        } else {
          printf( "%3u:%02u:%02u\n", 24*dd + dh, dm, ds )
        }
      } else {
        print "999:99:99"
      }
    } else {
      print "RUNNING"
    }
  }
'
