#!/bin/bash

# i3montage3d.sh  version 3.1  montage stacks of images

[[ $# -ne 2 && $# -ne 3 && $# -ne 4 ]] && echo "usage: $( basename ${0} ) file output [perm y [perm x]]" >&2 && exit 1

img=${1}
mnt=${2}


unset nx ny nz ox oy oz
eval $( i3stat -sh -l ${img} )

[[ ${dim} -ne 4 ]] && echo "$( basename ${0} ): ${img} is not an image stack" >&2 && exit 1

let col=${i3montage3dcol:-10}

let n=ni+col-1
let n=n/col

let sx=col*nx
let sy=n*ny

let i=0
let x=0
let y=0

set -e

i3new -t ${type} -s ${sx} ${sy} ${nz} -o 0 0 ${oz} -- ${mnt}

while [ ${i} -lt ${ni} ]; do
  i3cut -s ${nx} ${ny} ${nz} 1 -o ${ox} ${oy} ${oz} ${oi} -- ${img} ${mnt}.tmp
  i3paste -p ${x} ${y} ${oz} -- ${mnt}.tmp ${mnt}
  set +e
  let oi=oi+1
  let i=i+1
  let x=x+nx
  if [ ${x} -ge ${sx} ]; then
    let x=0
    let y=y+ny
  fi
  set -e
done

rm -f ${mnt}.tmp

[[ $# -eq 2 ]] && exit 0


mnt=${3}
prm=${mnt}.perm


i3permute -perm 1 0 0 0 0 1 0 -1 0 -- ${img} ${prm}

eval $( i3stat -sh -l ${prm} )

set +e

let n=ni+col-1
let n=n/col

let sx=col*nx
let sy=n*ny

let i=0
let x=0
let y=0

set -e

i3new -t ${type} -s ${sx} ${sy} ${nz} -o 0 0 ${oz} -- ${mnt}

while [ ${i} -lt ${ni} ]; do
  i3cut -s ${nx} ${ny} ${nz} 1 -o ${ox} ${oy} ${oz} ${oi} -- ${prm} ${mnt}.tmp
  i3paste -p ${x} ${y} ${oz} -- ${mnt}.tmp ${mnt}
  set +e
  let oi=oi+1
  let i=i+1
  let x=x+nx
  if [ ${x} -ge ${sx} ]; then
    let x=0
    let y=y+ny
  fi
  set -e
done

rm -f ${prm} ${mnt}.tmp

[[ $# -eq 3 ]] && exit 0


mnt=${4}
prm=${mnt}.perm


i3permute -perm 0 1 0 0 0 1 1 0 0 -- ${img} ${prm}

eval $( i3stat -sh -l ${prm} )

set +e

let n=ni+col-1
let n=n/col

let sx=col*nx
let sy=n*ny

let i=0
let x=0
let y=0

set -e

i3new -t ${type} -s ${sx} ${sy} ${nz} -o 0 0 -- ${oz} ${mnt}

while [ ${i} -lt ${ni} ]; do
  i3cut -s ${nx} ${ny} ${nz} 1 -o ${ox} ${oy} ${oz} ${oi} -- ${prm} ${mnt}.tmp
  i3paste -p ${x} ${y} ${oz} -- ${mnt}.tmp ${mnt}
  set +e
  let oi=oi+1
  let i=i+1
  let x=x+nx
  if [ ${x} -ge ${sx} ]; then
    let x=0
    let y=y+ny
  fi
  set -e
done

rm -f ${prm} ${mnt}.tmp
