#!/bin/sh
#
# i3polsize.sh  version 2.2  compute image size in polar coordinates
#

[ $# -ne 2 -a $# -ne 3  ] && { echo "usage: $( basename $0 ) x y [z]" >&2; exit 1; }

set -e

echo ${1} ${2} ${3} |
awk '{
  n = $1; if ( $2 < n ) { n = $2 }
  printf( "%u %u %u\n", int( 3.14159265358979323846 * n ), n / 2, $3 )
}' |
while read n r z; do
  echo "$( i3factor -ge 11 ${n} ) ${r} ${z}"
done
