#!/bin/bash
#
# i3apply.sh  version 2.1  apply transformations
#

[ $# -ne 3 ] && { echo "usage: $( basename $0 ) trf srcset dstset" >&2; exit 1; }

set -e

trf="${1}"

src="${2}"

dst="${3}"

R=$( awk ' { print $5, $6, $7, $8, $9, $10, $11, $12, $13, $14, $15, $16; exit } ' ../${trf} )

i3datalist ${I3D} ${src} |
awk ' { print $1, $2, $3, $4, $5, $6, $7, $8, $9, $10, $11, $12, $13, $14, $15, $16 }' |
while read id ix iy iz A; do
  RA=$( i3trf ${R} mul ${A} )
  echo ${id} ${ix} ${iy} ${iz} ${RA}
done |
sort -k 1,1 -k 4,4g -k 3,3g -k 2,2g >${PRFX}-app.trf

i3dataimport -dim ${DIM} ${I3D} ${dst} ${PRFX}-app.trf

rm -f ${PRFX}-app.trf
