#!/bin/bash
#
# i3combine.sh  version 2.1  combine alignment results into one set
#

set -e

# script directory
exe="i3align"

# combine alignments

cat ${SETS} |
while read map set; do

  trf=${exe}/mra-${set}.trf

  if [ -e ${trf} ]; then
    cat ${trf}
  fi

done |
sort -k 1,1 -k 4,4g -k 3,3g -k 2,2g >${exe}/mra.trf

cat ${SETS} |
while read map set; do

  trf=${exe}/mra-${set}.trf

  ali=${exe}/mra-${set}-ali.trf

  if [ -e ${trf} ]; then
    cat ${ali}
  fi

done |
sort -k 1,1 -k 4,4g -k 3,3g -k 2,2g >${exe}/mra-ali.trf

if [ $( cat ${exe}/mra.trf | wc -l ) -ne $( cat ${exe}/mra-ali.trf | wc -l ) ]; then
  echo "$( basename $0 ): inconsistent trf files" >&2
  exit 1
fi

cp ${I3D} ${PRFX}-new.i3d

i3dataimport -dim ${DIM} ${PRFX}-new.i3d ${SET}-mra ${exe}/mra-ali.trf

mv ${I3D} ${PRFX}-old.i3d

mv ${PRFX}-new.i3d ${I3D}
