#!/bin/bash
#
# i3class.sh  version 2.1  classification
#

set -e

# msa set
msaset="${SET}-${1}"

# min/max number of classes stored in the class-file
if [ ${CLSMIN} ]; then
  numclmin="${CLSMIN}"
  numclmax="${CLSMAX}"
  clinc="${CLSINC}"
else
  set +e
  clinc=1
  numclmin=${CLASSES}
  let numclmax=numclmin+clinc
  set -e
fi

# fraction of ignored high-variance outliers
hvo=${CLSHVO:-0.0}

# fraction of ignored high-variance class members
hvm=${CLSHVM:-0.0}

# hierarchical ascendant classification
cp ${I3D} ${CLS}.i3d
i3hac -log -cix -sval ${CLSFACT} -c ${numclmin} ${numclmax} -ci ${clinc} -hvo ${hvo} -hvm ${hvm} \
  -cls ${CLS}.cls ${CLS}.i3d ${msaset} ${CLS} ${PRFX}.coo \
  2>${CLS}.log
