#!/bin/bash
#
# i3msaexec.sh  version 2.1  calculate MSA
#

set -e

# msa stack file
msastack="${I3TMPDIR:-.}/${PRFX}-msa"

# msa mask
msamask="${MSAMASK:-${PRFX}-msamask.img}"

# check if msamask exists
if [ ! -e ${msamask} ]; then
  echo "$( basename $0 ): MSA mask not found" >&2; exit 1
fi

# execute

if [ x${USEIMAGIC} = xtrue ]; then
  i3msaimagic.sh ${msastack} ${msamask}
else
  i3msasvd.sh ${msastack}.img ${msamask}
fi
