#!/bin/bash
#
# i3msaimagic.sh  version 2.2  wrapper script for Imagic
#

set -e

# msa stack file
msastack="${1}"

# msa mask
msamask="${2}"

# temp files for MSA
unset imagic_tmp
if [ ${MSATMPDIR} ]; then
  imagic_tmp="${MSATMPDIR}/msa$( date '+%Y%m%d%H%M%S%N' )$$"
fi

# convert to Imagic format
i3compute -fmt imagic ${PRFX}-mask.hed = real ${2}

# run msa
${I3IMAGIC:-i3imagic-run.sh} ${msastack} ${PRFX} ${MSAFACT} ${imagic_tmp}

rm -f ${PRFX}-mask.hed ${PRFX}-mask.img

# montages

if [ x${MSAMONT} = xtrue ]; then

  i3montage -col ${MSAMONTCOL:-10} ${PRFX}-eigenim.hed ${PRFX}-eigenim-mont.img

  if [ ${DIM} = 3 -a y${YPERM} = ytrue ]; then
    i3permute -perm 1 0 0 0 0 1 0 -1 0 ${PRFX}-eigenim.hed ${PRFX}-eigenim-y.img
    i3montage -col ${MSAMONTCOL:-10} ${PRFX}-eigenim-y.img ${PRFX}-eigenim-y-mont.img
    rm -f ${PRFX}-eigenim-y.img
  fi

fi
