#!/bin/bash
#
# i3msamask.sh  version 2.2  generate a msa mask
#

set -e

if [ ${MSAMASK} ]; then

  msamask="${MSAMASK}"

else

  msamask="${PRFX}-msamask.img"

  if [ "${MSAPOLSIZE}" ]; then
    if [ "${MSAPOLSIZE}" = auto ]; then
      msamasksize="$( i3polsize.sh ${MSAIMGSIZE} )"
    else
      msamasksize="${MSAPOLSIZE}"
    fi
  else
    msamasksize="${MSAIMGSIZE}"
  fi

# create MSA mask

  i3new -c -s ${msamasksize} -val 1 ${msamask}

  [ "${MSAMASKOPT1}" ] && i3mask ${MSAMASKOPT1} ${msamask}
  [ "${MSAMASKOPT2}" ] && i3mask ${MSAMASKOPT2} ${msamask}
  [ "${MSAMASKOPT3}" ] && i3mask ${MSAMASKOPT3} ${msamask}

  i3compute ${msamask}.tmp.img = ${msamask} gt 0.5

  mv -f ${msamask}.tmp.img ${msamask}

fi

if [ "${MSAPOLSIZE}" ]; then
  unset MSAMASKSUPERPOS
fi

if [ "${MSAMASKSUPERPOS}" ]; then

  DIM=$( echo ${MSAIMGSIZE} | awk '{ print NF }' )

  if [ "${MSAMASKSUPERPOS}" = totsum ]; then
    if [ ! x${GLBLAVG} = xtrue ]; then
      echo "parameter GLBLAVG is not set" >&2; exit
    fi
    i3resample -D ${MSAIMGSMP} -s ${MSAIMGSIZE} -c ${SET}-${1}-totsum.img ${msamask}.superpos.img
  else
    cp ${MSAMASKSUPERPOS} ${msamask}.superpos.img
  fi

  if [ ${DIM} = 2 ]; then

    i3compute ${msamask}.superpos.img \* ${msamask}

  else

    i3compute ${msamask}.superpos.img \* ${msamask}

    if [ y${YPERM} = ytrue ]; then

      i3permute -perm 1 0 0 0 0 1 0 -1 0 ${msamask} ${msamask}.y.img

      i3permute -perm 1 0 0 0 0 1 0 -1 0 ${msamask}.superpos.img ${msamask}.superpos.y.img

    fi

  fi

fi
