#!/bin/bash
#
# i3selectapply.sh  version 2.1  apply transformations
#

set -e

msaset="${SET}-${1}"

set="${SET}-ali"

app="${PRFX}-ali"

cp ${CLS}.i3d ${app}.i3d

if [ ${SELCLS} ]; then

  dir="${SEL}"

  cln="$( printf "%03u" ${SELCLS} )"

  i3datalist -cls ${CLS}.i3d ${CLS}-${cln} >${set}.trf

  mkdir ${app}

  if [ "x${1}" = xsingle ]; then
    trf="ref-all-ali.trf"
  else
    trf="ref-ali.trf"
  fi

  if [ ${DIM} = 2 ]; then

    awk -v c="box-${cln}-" ' {
      sub( c, "", $1 ) 
      print $1, $4, $5, $6, $7, $8, $9
    } ' ${dir}/${trf} |
    while read id R; do
      awk -v i=${id} ' $11 == i { print $1, $2, $3, $4, $5, $6, $7, $8, $9 }' ${set}.trf |
      while read id ix iy A; do
        RA=$( i3trf ${R} mul ${A} )
        echo ${id} ${ix} ${iy} ${RA}
      done |
      sort -k 1,1 -k 3,3g -k 2,2g |
      tee ${app}/${set}-${id}-ali.trf
    done |
    sort -k 1,1 -k 3,3g -k 2,2g >${app}/${set}-ali.trf

  else

    awk -v c="box-${cln}-" ' {
      sub( c, "", $1 ) 
      print $1, $5, $6, $7, $8, $9, $10, $11, $12, $13, $14, $15, $16
    } ' ${dir}/${trf} |
    while read id R; do
      awk -v i=${id} ' $18 == i { print $1, $2, $3, $4, $5, $6, $7, $8, $9, $10, $11, $12, $13, $14, $15, $16 }' ${set}.trf |
      while read id ix iy iz A; do
        RA=$( i3trf ${R} mul ${A} )
        echo ${id} ${ix} ${iy} ${iz} ${RA}
      done |
      sort -k 1,1 -k 4,4g -k 3,3g -k 2,2g |
      tee ${app}/${set}-${id}-ali.trf
    done |
    sort -k 1,1 -k 4,4g -k 3,3g -k 2,2g >${app}/${set}-ali.trf

  fi

  cp ${app}/${set}-ali.trf ${set}.trf

else

  i3datalist ${CLS}.i3d ${msaset} >${set}.trf

fi

i3dataimport -dim ${DIM} ${app}.i3d ${set} ${set}.trf

rm -f ${set}.trf
