#!/bin/bash
#
# i3selectcombinesingle.sh  version 2.2  combine results of individual alignments
#

set -e

# set input file paths

dir="${SEL}"

export I3FILEPATH=".:${dir}"


# select

i3contents ${SEL}.i3d 2>&1 |
awk ' /ref-[0-9]+-[0-9]+ / { print $2 } ' |
while read s; do
  head -n 1 ${dir}/${s}-single.trf
done |
cat >${dir}/ref-ali.trf

awk '{ $1 = $1"-avg"; print }' ${dir}/ref-ali.trf >${dir}/ref-avg-ali.trf

i3d=${SEL}-tmp.i3d

cp ${SEL}.i3d ${i3d}

i3dataimport -dim ${DIM} ${i3d} refs-avg ${dir}/ref-avg-ali.trf

i3window -clp -s ${MOTIFSIZE} ${i3d} refs-avg ${SEL}.img

mv -f ${i3d} ${SEL}.i3d

# create montages

if [ x${SELMONT} = xtrue ]; then

  i3montage -col ${SELMONTCOL:-10} ${SEL}.img ${SEL}-mont.img

  if [ ${DIM} = 3 -a y${YPERM} = ytrue ]; then
    i3permute -perm 1 0 0 0 0 1 0 -1 0 ${SEL}.img ${SEL}-y.img
    i3montage -col ${SELMONTCOL:-10} ${SEL}-y.img ${SEL}-y-mont.img
    rm -f ${SEL}-y.img
  fi

fi
