#!/bin/bash

set -e


# parameter file (mraparam.sh or abcparam.sh)
source mraparam.sh


# output file name
img="afilter.img"


# uncomment this if the filter is for raw motif alignment or class average alignment
size="${MOTIFSIZE}"

# uncomment this if the filter is for the MSA stack
# size="${MSAIMGSIZE}"


# create new image filled with ones
i3new -f -s ${size} -val 1 -- ${img}

# uncomment to set plane z=0 to zero (equator if filament axis is along z-axis)
i3mask -minv -mu pixel -mw 0 0 1 -mc 0 0 0 -- ${img}

# uncomment to set planes at z=8 and z=-8 to zero
# i3mask -minv -mu pixel -mw 0 0 1 -mc 0 0  8 -- ${img}
# i3mask -minv -mu pixel -mw 0 0 1 -mc 0 0 -8 -- ${img}
